﻿Imports System.Net
Imports Newtonsoft
Imports Newtonsoft.Json.Linq

Module YandexLocation

    Public Class YandexLocatin

        Dim adres As String
        Dim respone As String
        Dim Coordinates As String

        Sub New(adres As String)
            Me.adres = adres
            Using WebClient = New WebClient
                WebClient.Encoding = System.Text.Encoding.UTF8
                Me.respone = WebClient.DownloadString("https://geocode-maps.yandex.ru/1.x/?format=json&geocode=" + Replace_Adres())
            End Using
            JSONDECODE()
        End Sub

        Private Function Replace_Adres()
            Dim url_adres As String = Replace(adres, " ", "+")
            Return url_adres
        End Function
        Private Sub JSONDECODE()
            Dim MyJson As JObject = Json.JsonConvert.DeserializeObject(respone)
            '[JSON].response.GeoObjectCollection.metaDataProperty.GeocoderResponseMetaData.results
            '[JSON].response.GeoObjectCollection.featureMember.[0].GeoObject.Point.pos
            If MyJson("response")("GeoObjectCollection")("metaDataProperty")("GeocoderResponseMetaData")("results").ToString = "0" Then
                Coordinates = Nothing
            Else
                Coordinates = MyJson("response")("GeoObjectCollection")("featureMember")(0)("GeoObject")("Point")("pos")
            End If
        End Sub

        Public Function lat()
            If Coordinates IsNot Nothing Then
                Dim cord As Array = Split(Coordinates, " ")
                Dim l1 As String = (cord(1))
                Return l1
            Else
                Return ""
            End If
        End Function

        Public Function lng()
            If Coordinates IsNot Nothing Then
                Dim cord As Array = Split(Coordinates, " ")
                Dim l1 As String = (cord(0))
                Return l1
            Else
                Return ""
            End If
        End Function
    End Class
End Module
